#!/bin/sh

DGROOT=`../src/delegated -Fdump DGROOT`
echo "#####################################################################"
echo "# installing {$*} at DGROOT/subin/" where
echo "#   DGROOT=$DGROOT"
echo "# if above DGROOT is not appropriate, then set it as environment"
echo "# variable before doing 'make install'"
echo "#####################################################################"
set -x
LIBDIR=$DGROOT/lib
ETCDIR=$DGROOT/etc
SUBINDIR=$DGROOT/subin

if [ ! -d "$LIBDIR" ]; then mkdir "$LIBDIR"; fi
if [ ! -d "$SUBINDIR" ]; then mkdir "$SUBINDIR"; fi

if [ -d $LIBDIR ]; then
	cp -p /etc/resolv.conf $ETCDIR
	cp -p /lib/ld*so* $LIBDIR
	cp -p /lib/libc.so.* $LIBDIR
	cp -p /lib/libnsl.so.* $LIBDIR
	(cd $SUBINDIR; rm -f $*)
	mv $* $SUBINDIR
	cd $SUBINDIR

	echo "#### setting the owner of $*"

	### sudo for MacOS X
	sudo sh -c "chown root $*; chmod 6550 $*"

	if [ $? != 0 ]; then
		su root -c "chown root $*; chmod 6550 $*"
	fi

	set +x
	if [ $? = 0 ]; then
		echo "################################"
		echo "#  OK, installed successfully  #"
		echo "################################"
		pwd
		ls -l $*
	fi
fi
